/**
* Class: TestLog
*
* Author:
* Kelvin Luck
*/

import com.kelvinluck.util.SOSLogPublisher;
import com.kelvinluck.util.LogWrapper;

class TestLog 
{
	
	/**
	* Function: TestLog
	* Constructor
	**/
	function TestLog()
	{
	}
	
	/**
	* Function: main
	* Entry point to the program....
	*/
	public static function main() : Void 
	{
		LogWrapper.getInstance().init();
		LogWrapper.getLog().addPublisher(new SOSLogPublisher("myAppsName"));
		// log messages at different levels
		LogWrapper.getLog().fatal("This is a fatal error :'(");
		LogWrapper.getLog().error("This is an error :(");
		LogWrapper.getLog().warn("This is a warning, warning, warning");
		LogWrapper.getLog().info("This is information");
		LogWrapper.getLog().debug("This is debugging info");
		LogWrapper.getLog().debug("This is &method. For making this recipe (testing unescaped ampersands)");
		// an Array (folded by default in SOS)
		LogWrapper.getLog().debug([1,2,3,{a:"Part A", b:"Part B"}, "Some text", 99]);
		// an anoynomous object (also folded by default)
		LogWrapper.getLog().error({a:"this is a", b:"and this is b"});
		// an object with a toString method (folded by default with the name from the toString method shown)...
		var testObj:Foo = new Foo("bar", 2000, ["A", "B", "C", "DDDDDD"]);
		LogWrapper.getLog().warn(testObj);
		 
		TRACE("This is a fatal error :'(", LogWrapper.FATAL);
		TRACE("This is an error :(", LogWrapper.ERROR);
		TRACE("This is a warning, warning, warning", LogWrapper.WARN);
		TRACE("This is information", LogWrapper.INFO);
		LogWrapper.logCallingFile = false; // stops the file information about where the log was called from being traced...
		TRACE("This is debugging info", LogWrapper.DEBUG);
		LogWrapper.logCallingFile = true;
		// an Array (folded by default in SOS)
		TRACE([1,2,3,{a:"Part A", b:"Part B"}, "Some text", 99]);
		// an anoynomous object (also folded by default)
		TRACE({foo:"bar", bar:"pub", withAmp:"this&that"}, LogWrapper.WARN);
		// some XML...
		var x:XML = new XML("<testNode><blah att=\"1\" /></testNode>");
		TRACE(x);
	}
	/**
	* Function: toString
	**/
	public function toString():String
	{
		return "[TestLog]";
	}
}